/* BurpExtender.java - Burp extender main class
 *
 * Automated modification of websockets messages requires the implementation of
 * a Java class that implements the interface evilwan.WSFIlter That implementation class
 * should have a constructor that is to be called without arguments.
 *
 * Note: this implementation of a Burp extension only works with Burp Professional version 1.6
 *
 * In order to implement this extension, a number of educated guesses were used (such as the assumption
 * that the table of intercepted websocket messases is based on a class that encapsulates all relevant
 * data for one websocket message), as well as dumping the entire Burp GUI compoment tree and, in a
 * couple of situations, even dumping obfuscated class files with "javap". Additional information was
 * found using Java reflection.
 *
 * In brief: it is the expectation (hope) of the author that the functionality covered by this
 * extension will be provided by the next release of Burp, but in the mean time this extension does
 * allow to save websocket trafic in an XML file, as well as providing automatic modifications of
 * websocket messages by means of a custom filter.
 *
 * Enjoy.
 *
 * Copyright (c) 2014 Eddy Vanlerberghe.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of Eddy Vanlerberghe shall not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY EDDY VANLERBERGHE ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL EDDY VANLERBERGHE BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

package burp;

import evilwan.*;
import java.awt.*;

public class BurpExtender implements IBurpExtender, ITab {
    // {{ Class members }}

    private final static String TAB_CAPTION = "WS Stuff";
    private final static String EXT_NAME = "WebSockets Stuff v0.1.03";

    // {{ Instance members }}
    
    private IBurpExtenderCallbacks	_cb = null;
    private Component			_tabpane = null;

    // {{ Class methods }}
    
    // {{ Constructors }}
    
    // {{ Instance methods }}

    //
    // IBurpExtender interface
    //
    public void registerExtenderCallbacks(IBurpExtenderCallbacks cb) {
	_cb = cb;
	_cb.setExtensionName(EXT_NAME);
	_tabpane = new WSGui();
	_cb.addSuiteTab(this);
    }
    
    //
    // ITab interface
    //
    public String getTabCaption() {
	return TAB_CAPTION;
    }
    public Component getUiComponent() {
	return _tabpane;
    }
}
